org.apache.commons.compress.java.util.jar

## Interface Pack200.Packer

- All Known Implementing Classes:
    Pack200PackerAdapter
  Enclosing class:
    Pack200

      public static interface Pack200.Packer

  The interface defining the API for converting a JAR file to an output stream in the Pack200 format.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `CLASS_ATTRIBUTE_PFX` the format of a class attribute name.
    `static String` | `CODE_ATTRIBUTE_PFX` the format of a code attribute name.
    `static String` | `DEFLATE_HINT` the deflation hint to set in the output archive.
    `static String` | `EFFORT` the indicated amount of effort to use in compressing the archive.
    `static String` | `ERROR` a String representation for `error`.
    `static String` | `FALSE` a String representation of `false`.
    `static String` | `FIELD_ATTRIBUTE_PFX` the format of a field attribute name.
    `static String` | `KEEP` a String representation for `keep`.
    `static String` | `KEEP_FILE_ORDER` decide if all elements shall transmit in their original order.
    `static String` | `LATEST` a String representation for `latest`.
    `static String` | `METHOD_ATTRIBUTE_PFX` the format of a method attribute name.
    `static String` | `MODIFICATION_TIME` if it shall attempt to determine the latest modification time if this is set to `LATEST`.
    `static String` | `PASS` a String representation of `pass`.
    `static String` | `PASS_FILE_PFX` the file that will not be compressed.
    `static String` | `PROGRESS` packer progress as a percentage.
    `static String` | `SEGMENT_LIMIT` The number of bytes of each archive segment.
    `static String` | `STRIP` a String representation of `strip`.
    `static String` | `TRUE` a String representation of `true`.
    `static String` | `UNKNOWN_ATTRIBUTE` the action to take if an unknown attribute is encountered.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addPropertyChangeListener(PropertyChangeListener listener)` add a listener for PropertyChange events
    `void` | `pack(JarFile in, OutputStream out)` Pack the specified JAR file to the specified output stream.
    `void` | `pack(JarInputStream in, OutputStream out)` Pack the data from the specified jar input stream to the specified output stream.
    `SortedMap<String,String>` | `properties()` Returns a sorted map of the properties of this packer.
    `void` | `removePropertyChangeListener(PropertyChangeListener listener)` remove a listener

- - ### Field Detail

    - #### CLASS_ATTRIBUTE_PFX

          static final String CLASS_ATTRIBUTE_PFX

      the format of a class attribute name.
      See Also:
        Constant Field Values

    - #### CODE_ATTRIBUTE_PFX

          static final String CODE_ATTRIBUTE_PFX

      the format of a code attribute name.
      See Also:
        Constant Field Values

    - #### DEFLATE_HINT

          static final String DEFLATE_HINT

      the deflation hint to set in the output archive.
      See Also:
        Constant Field Values

    - #### EFFORT

          static final String EFFORT

      the indicated amount of effort to use in compressing the archive.
      See Also:
        Constant Field Values

    - #### ERROR

          static final String ERROR

      a String representation for `error`.
      See Also:
        Constant Field Values

    - #### FALSE

          static final String FALSE

      a String representation of `false`.
      See Also:
        Constant Field Values

    - #### FIELD_ATTRIBUTE_PFX

          static final String FIELD_ATTRIBUTE_PFX

      the format of a field attribute name.
      See Also:
        Constant Field Values

    - #### KEEP

          static final String KEEP

      a String representation for `keep`.
      See Also:
        Constant Field Values

    - #### KEEP_FILE_ORDER

          static final String KEEP_FILE_ORDER

      decide if all elements shall transmit in their original order.
      See Also:
        Constant Field Values

    - #### LATEST

          static final String LATEST

      a String representation for `latest`.
      See Also:
        Constant Field Values

    - #### METHOD_ATTRIBUTE_PFX

          static final String METHOD_ATTRIBUTE_PFX

      the format of a method attribute name.
      See Also:
        Constant Field Values

    - #### MODIFICATION_TIME

          static final String MODIFICATION_TIME

      if it shall attempt to determine the latest modification time if this is set to `LATEST`.
      See Also:
        Constant Field Values

    - #### PASS

          static final String PASS

      a String representation of `pass`.
      See Also:
        Constant Field Values

    - #### PASS_FILE_PFX

          static final String PASS_FILE_PFX

      the file that will not be compressed.
      See Also:
        Constant Field Values

    - #### PROGRESS

          static final String PROGRESS

      packer progress as a percentage.
      See Also:
        Constant Field Values

    - #### SEGMENT_LIMIT

          static final String SEGMENT_LIMIT

      The number of bytes of each archive segment.
      See Also:
        Constant Field Values

    - #### STRIP

          static final String STRIP

      a String representation of `strip`.
      See Also:
        Constant Field Values

    - #### TRUE

          static final String TRUE

      a String representation of `true`.
      See Also:
        Constant Field Values

    - #### UNKNOWN_ATTRIBUTE

          static final String UNKNOWN_ATTRIBUTE

      the action to take if an unknown attribute is encountered.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### addPropertyChangeListener

          void addPropertyChangeListener(PropertyChangeListener listener)

      add a listener for PropertyChange events
      Parameters:
        `listener` - the listener to listen if PropertyChange events occurs

    - #### pack

          void pack(JarFile in,
                    OutputStream out)
             throws IOException

      Pack the specified JAR file to the specified output stream.
      Parameters:
        `in` - JAR file to be compressed.
        `out` - stream of compressed data.
      Throws:
        `IOException` - if I/O exception occurs.

    - #### pack

          void pack(JarInputStream in,
                    OutputStream out)
             throws IOException

      Pack the data from the specified jar input stream to the specified output stream.
      Parameters:
        `in` - stream of uncompressed JAR data.
        `out` - stream of compressed data.
      Throws:
        `IOException` - if I/O exception occurs.

    - #### properties

          SortedMap<String,String> properties()

      Returns a sorted map of the properties of this packer.
      Returns:
        the properties of the packer.

    - #### removePropertyChangeListener

          void removePropertyChangeListener(PropertyChangeListener listener)

      remove a listener
      Parameters:
        `listener` - listener to remove

Copyright © 2002–2022 The Apache Software Foundation. All rights reserved.